Unit OPlan;
{ objet reprsentant le plan muni d'un repre }
{ K.B. janvier 1999 }

INTERFACE

Uses Classes, WinTypes, WinProcs, Graphics, UPCalc;

Const
 { nombre de pixels par unit pris par dfaut }
 defUnX:Real = 20.0;
 defUnY:Real = 20.0;
 { options pour le fond }
 opAxes = 1;
 opPoints = 2;
 opQuadrillage = 4;
 { couleurs }
 ColorAttr: array [0..15] of TColorRef = { ordre BGR !!! }
 (0,$800000,$008000,$808000,$000080,$8000FF,$008080,$C0C0C0,$808080,
  $FF0000,$00FF00,$FFFF00,$0000FF,$FF00FF,$00FFFF,$FFFFFF);

 NOIR=0; BLEU=1; VERT=2; CYAN=3; ROUGE=4; MAGENTA=5; BRUN=6;
 GRISCLAIR=7; GRIS=8; BLEUCLAIR=9; VERTCLAIR=10; CYANCLAIR=11;
 ROUGECLAIR=12; MAGENTACLAIR=13; JAUNE=14; BLANC=15;

Type
 TStr8 = String[8];

 PPlanView = ^TPlanView;
 TPlanView = object
  Largeur, Hauteur : Integer;
  { couleurs utilises }
  CouleurFond,
  CouleurTrace,
  CouleurAxes : Integer;
  ModeCouleur : Boolean;
  { options Axes et Points }
  Options : Word;
  { fentre courante pour l'utilisateur }
  XgFen, XdFen,
  YbFen, YhFen : Real;
  {point courant}
  XCur,YCur   : Integer;
  { nombre de pixels par unit }
  UnX, UnY   : Real;
  { unit de graduation des axes }
  PasAxeX,PasAxeY  : Real;
  { facteur de correction pour les repres orthonorms }
  Constructor Init(l,h:Integer);
  { initialisation }
  { l'origine se trouve au centre de la zone; l'unit est de 20 pixels }
  Destructor Done; virtual;
  Procedure BackGround(canvas:TCanvas); virtual;
  { dessin du fond : effacement avec la couleur BkColor + axes et points }
  Procedure SetDim(l,h:Integer);
  { change la largeur et la hauteur }
  Procedure Fenetre(x1,x2,y1,y2:Real);
  { fixe les coordonnes utilisateurs; recalcule UnX et UnY }
  Procedure FenetreOrtho(x,y,u:Real);
  { repre orthonorm avec (x,y) dans le coin infrieur gauche et u
    comme unit }
  Procedure FenetreOrthoCentre(u:Real);
  { repre orthonorm avec origine au centre de la zone utilise }
  Procedure FixeCouleur(col:Integer);
  { change la couleur de trac }
  Procedure TraceVers(canvas:TCanvas;x,y:Real;mode:Byte);
  { dplace le point courant en (x,y)
    si mode=0, sans laisser de trace
    si mode=1 en traant un trait continu
    si mode=2 avec un trait en pointill }
  Procedure CoordPlan(x,y:Integer;Var xu,yu:Real);
  { conversion coordonnes locales cran en coordonnes utilisateur }
  Procedure CoordEcran(x,y:Real;Var xs,ys:Integer);
  { conversion coordonnes utilisateur en coordonnes cran }
  Procedure Axes(canvas:TCanvas; col:Integer);
  { trace les axes de coordonnes }
  Procedure Points(canvas:TCanvas; col:Integer);
  { montre les points de coordonnes entires }
  Procedure Quadrille(canvas:TCanvas; col:Integer);
  { dessine un quadrillage }
  Function GetCoordMsg(x,y:Integer):String;
  { renvoi d'une chane donnant les coordonnes d'un point cran }
  Function PasGraduX:Real;
  { calcule le pas de graduation }
  Function PasGraduY:Real;
  { calcule le pas de graduation }
  Procedure TraceCercle(canvas:TCanvas; xc,yc,r:Real);
  { trace un cercle de centre (xc,yc) et de rayon r }
  Procedure TraceDroite(canvas:TCanvas; a,b,c:Real);
  { trace la droite d'quation ax+by+c=0 }
  Procedure TracePoint(canvas:TCanvas; x,y:Real;Nom:TStr8);
  { trace un point et le nomme }
 End;


IMPLEMENTATION

{ objet TPlanView }

Constructor TPlanView.Init(l,h:Integer);
Begin
 Largeur:=l; Hauteur:=h;
 ModeCouleur:=true;
 CouleurTrace:=Noir;
 CouleurFond:=Blanc;
 CouleurAxes:=Noir;
 PasAxeX:=0;
 PasAxeY:=0;
 {fentre courante pour l'utilisateur}
 FenetreOrthoCentre(defUnX);
 {point courant}
 CoordEcran(0,0,xcur,ycur);
End;

Destructor TPlanView.Done;
Begin
End;

Procedure TPlanView.SetDim(l,h:Integer);
Begin
 Largeur:=l; Hauteur:=h;
 Fenetre(xgfen,xdfen,ybfen,yhfen);
End;

Procedure TPlanView.BackGround(canvas:TCanvas);
Var col:Integer;
Begin
 with canvas do
  begin
   if ModeCouleur then Col:=CouleurFond
   else Col:=Blanc;
   Brush.Color:=ColorAttr[Col];
   Pen.Color:=ColorAttr[Col];
   Rectangle(0,0,Largeur,Hauteur);
  end;
 if ModeCouleur then Col:=CouleurAxes
 else Col:=Noir;
 if Options and opAxes<>0 then
  begin
   if PasAxeX<=0 then PasAxeX:=PasGraduX;
   if PasAxeY<=0 then PasAxeY:=PasGraduY;
   Axes(canvas,col);
  end;
 if Options and opPoints<>0 then
  begin
   if PasAxeX<=0 then PasAxeX:=PasGraduX;
   if PasAxeY<=0 then PasAxeY:=PasGraduY;
   Points(canvas,col);
  end;
 if Options and opQuadrillage<>0 then
  begin
   if PasAxeX<=0 then PasAxeX:=PasGraduX;
   if PasAxeY<=0 then PasAxeY:=PasGraduY;
   Quadrille(canvas,col);
  end;
End;

Function MaxR(x,y:Real):Real;
Begin
 if x>y then maxr:=x else maxr:=y;
End;

Function MinR(x,y:Real):Real;
Begin
 if x<y then minr:=x else minr:=y;
End;

Procedure TPlanView.Fenetre(x1,x2,y1,y2:Real);
Begin
 if x1=x2 then x2:=x1+1;
 if y1=y2 then y2:=y1+1;
 XgFen:=minr(x1,x2);
 XdFen:=maxr(x1,x2);
 YbFen:=minr(y1,y2);
 YhFen:=maxr(y1,y2);
 UnX:=Largeur/(XdFen-XgFen);
 UnY:=Hauteur/(YhFen-YbFen);
End;

Procedure TPlanView.FenetreOrtho(x,y,u:Real);
Begin
 Fenetre(x,x+Largeur/u,y,y+Hauteur/u);
End;

Procedure TPlanView.FenetreOrthoCentre(u:Real);
Var xx,yy:Real;
Begin
 xx:=Largeur/(2*u);
 yy:=Hauteur/(2*u);
 Fenetre(-xx,xx,-yy,yy);
End;

Procedure TPlanView.FixeCouleur(col:Integer);
Begin
 CouleurTrace:=col;
End;

Procedure TPlanView.CoordPlan(x,y:Integer; Var xu,yu:Real);
Begin
 xu:=x/UnX+XgFen;
 yu:=YhFen-y/UnY;
End;

Procedure TPlanView.CoordEcran(x,y:Real; Var xs,ys:Integer);
Var t : Real;

 Function Recadre(r:Real):Integer;
 { ramne un rel dans les limites Integer }
 Begin
  if abs(r)<MaxInt-1 then
   Recadre:=round(r)
  else if r>0 then Recadre:=MaxInt-1
  else Recadre:=-MaxInt+1;
 End;

Begin
 t:=PMul(PSub(x,XgFen),UnX);
 if IsPCalcError then
  begin
   if x>0 then xs:=MaxInt-1
   else xs:=-MaxInt+1;
  end
 else xs:=Recadre(t);
 t:=PMul(PSub(YhFen,y),UnY);
 if IsPCalcError then
  begin
   if y>0 then ys:=-MaxInt+1
   else ys:=MaxInt-1;
  end
 else ys:=Recadre(t);
End;

Procedure TPlanView.TraceVers(canvas:TCanvas; x,y:Real; mode:Byte);
Begin
 with canvas do
  begin
   { rtablir la position courante }
   moveto(xcur,ycur);
   { convertir coordonnes utilisateurs en coordonnes cran }
   CoordEcran(x,y,xcur,ycur);
   { dplacement en fonction du mode }
   if mode=0 then
    moveto(xcur,ycur)
   else begin
    if ModeCouleur then Pen.Color:=ColorAttr[CouleurTrace]
    else Pen.Color:=ColorAttr[noir];
    case mode of
     2 : Pen.Style:=psDot;
     else Pen.Style:=psSolid;
     end;
    lineto(xcur,ycur);
   end;
  end;
End;

Function TPlanView.PasGraduX:Real;
{ calcule un pas de graduation en fonction de la largeur de la fentre }
Var r, k, ln10 : Real;
Begin
 ln10:=Ln(10.0);
 r:=(XdFen-XgFen)/10;
 k:=Ln(r)/ln10;
 if k>=0 then k:=Int(k)
 else k:=-1-Int(-k);
 r:=exp(k*ln10);
 if r*UnX<defUnX then r:=2*r;
 if r*UnX<defUnX then r:=2.5*r;
 if r*UnX<defUnX then r:=2*r;
 PasGraduX:=r;
End;

Function TPlanView.PasGraduY:Real;
{ calcule un pas de graduation en fonction de la hauteur de la fentre }
Var r, k, ln10 : Real;
Begin
 ln10:=Ln(10.0);
 r:=(YhFen-YbFen)/10;
 k:=Ln(r)/ln10;
 if k>=0 then k:=Int(k)
 else k:=-1-Int(-k);
 r:=exp(k*ln10);
 if r*UnY<defUnY then r:=2*r;
 if r*UnY<defUnY then r:=2.5*r;
 if r*UnY<defUnY then r:=2*r;
 PasGraduY:=r;
End;

Procedure TPlanView.Axes(canvas:TCanvas; col:Integer);
Const dep = 4;
Var i, dx, dy : Real;
    XOrig, YOrig : Real;
    xs, ys, decx, decy : Integer;
    S : String[10];
Begin
 with canvas do
  begin
   Pen.Color:=ColorAttr[col];
   Pen.Style:=psSolid;
   Font.Color:=ColorAttr[col];
   Font.Name:='Arial';
   Font.Size:=8;
   dx:=Ln(PasAxeX)/Ln(10);
   dy:=Ln(PasAxeY)/Ln(10);
   if dx<0 then dx:=1+Int(-dx)
   else dx:=0;
   if dy<0 then dy:=1+Int(-dy)
   else dy:=0;
   decx:=round(dx);
   decy:=round(dy);
   if (XgFen<0) and (XdFen>0) then XOrig:=0
   else XOrig:=XgFen;
   if (YbFen<0) and (YhFen>0) then YOrig:=0
   else YOrig:=YbFen;
   { axe des X }
   CoordEcran(XgFen,YOrig,xs,ys);
   MoveTo(xs,ys);
   CoordEcran(XdFen,YOrig,xs,ys);
   LineTo(xs,ys);
   { flche }
   LineTo(xs-dep,ys+dep);
   MoveTo(xs,ys);
   LineTo(xs-dep,ys-dep);
   { axe des Y }
   CoordEcran(XOrig,YbFen,xs,ys);
   MoveTo(xs,ys);
   CoordEcran(XOrig,YhFen,xs,ys);
   LineTo(xs,ys);
   { flche }
   LineTo(xs-dep,ys+dep);
   MoveTo(xs,ys);
   LineTo(xs+dep,ys+dep);
   { criture des graduations }
   { x>0 }
   i:=XOrig+PasAxeX;
   while i<XdFen do
    begin
     CoordEcran(i,YOrig,xs,ys);
     MoveTo(xs,ys-dep);
     LineTo(xs,ys+dep);
     Str(i:0:decx,S);
     if i>0 then S:='+'+S;
     TextOut(xs+2,ys-14,S);
     i:=i+PasAxeX;
    end;
   { x<0 }
   i:=XOrig-PasAxeX;
   while i>XgFen do
    begin
     CoordEcran(i,YOrig,xs,ys);
     MoveTo(xs,ys-dep);
     LineTo(xs,ys+dep);
     Str(i:0:decx,S);
     if i>0 then S:='+'+S;
     TextOut(xs+2,ys-14,S);
     i:=i-PasAxeX;
    end;
   { y>0 }
   i:=YOrig+PasAxeY;
   while i<YhFen do
    begin
     CoordEcran(XOrig,i,xs,ys);
     MoveTo(xs+dep,ys);
     LineTo(xs-dep,ys);
     Str(i:0:decy,S);
     if i>0 then S:='+'+S;
     TextOut(xs+4,ys,S);
     i:=i+PasAxeY;
    end;
   { y<0 }
   i:=YOrig-PasAxeY;
   while i>YbFen do
    begin
     CoordEcran(XOrig,i,xs,ys);
     MoveTo(xs+2,ys);
     LineTo(xs-2,ys);
     Str(i:0:decy,S);
     if i>0 then S:='+'+S;
     TextOut(xs+4,ys,S);
     i:=i-PasAxeY;
    end;
 end;
End;

Procedure TPlanView.Quadrille(canvas:TCanvas; col:Integer);
Var x,y: Real;
Begin
 CouleurTrace:=col;
 x:=int(XgFen/PasAxeX)*PasAxeX;
 {if x<0 then x:=x+PasAxeX;}
 while x<XdFen do
  begin
   if abs(x)>1e-6 then
    begin
     TraceVers(canvas,x,YbFen,0);
     TraceVers(canvas,x,YhFen,2);
    end;
   x:=x+PasAxeX;
  end;
 y:=int(YbFen/PasAxeY)*PasAxeY;
 {if y<0 then y:=y+PasAxeY;}
 while y<YhFen do
  begin
   if abs(y)>1e-6 then
    begin
     TraceVers(canvas,XgFen,y,0);
     TraceVers(canvas,XdFen,y,2);
    end;
   y:=y+PasAxeY;
  end;
End;

Procedure TPlanView.Points(canvas:TCanvas; col:Integer);
Var xs,ys : Integer;
    i,j : Real;
    XOrig,YOrig : Real;
Begin
 with canvas do
  begin
   Pen.Color:=ColorAttr[Col];
   if (XgFen<0) and (XdFen>0) then XOrig:=0
   else XOrig:=XgFen;
  if (YbFen<0) and (YhFen>0) then YOrig:=0
  else YOrig:=YbFen;
  CoordEcran(XOrig,YOrig,xs,ys);
  i:=XOrig;
  while i<XdFen do
   begin
    j:=YOrig;
    while j<YhFen do
     begin
      CoordEcran(i,j,xs,ys);
      Moveto(xs-1,ys); lineto(xs+2,ys);
      Moveto(xs,ys-1); lineto(xs,ys+2);
      j:=j+PasAxeY;
     end;
    j:=YOrig;
    while j>YbFen do
     begin
      CoordEcran(i,j,xs,ys);
      Moveto(xs-1,ys); lineto(xs+2,ys);
      Moveto(xs,ys-1); lineto(xs,ys+2);
      j:=j-PasAxeY;
     end;
    i:=i+PasAxeX;
   end;
  i:=XOrig;
  while i>XgFen do
   begin
    j:=YOrig;
    while j<YhFen do
     begin
      CoordEcran(i,j,xs,ys);
      Moveto(xs-1,ys); lineto(xs+2,ys);
      Moveto(xs,ys-1); lineto(xs,ys+2);
      j:=j+PasAxeY;
     end;
    j:=YOrig;
    while j>YbFen do
     begin
      CoordEcran(i,j,xs,ys);
      Moveto(xs-1,ys); lineto(xs+2,ys);
      Moveto(xs,ys-1); lineto(xs,ys+2);
      j:=j-PasAxeY;
     end;
    i:=i-PasAxeX;
   end;
 end;
End;

Function TPlanView.GetCoordMsg(x,y:Integer):String;
Var Sx,Sy : String[40];
    xu,yu,d : Real;
    dec : Byte;
    Orig  : TPoint;
Begin
 if PasAxeX<=0 then PasAxeX:=PasGraduX;
 if PasAxeY<=0 then PasAxeY:=PasGraduY;
 CoordPlan(x,y,xu,yu);
 d:=Ln(PasAxeX/10)/Ln(10);
 if d<0 then d:=1+Int(-d)
 else if d<=0.5 then d:=1 else d:=0;
 dec:=round(d);
 str(xu:0:dec,Sx);
 d:=Ln(PasAxeY/10)/Ln(10);
 if d<0 then d:=1+Int(-d)
 else if d<=0.5 then d:=1 else d:=0;
 dec:=round(d);
 str(yu:0:dec,Sy);
 GetCoordMsg:='('+Sx+';'+Sy+')';
End;

Procedure TPlanView.TraceCercle(canvas:TCanvas; XC,YC,R: Real);
Var
 x1,y1 : Integer;
 rayon : Word;
Begin
 CoordEcran(XC,YC,x1,y1);
 if R*UnX>64000 then rayon:=64000
 else rayon:=round(r*UnX);
 with canvas do
  begin
   Pen.Color:=ColorAttr[CouleurTrace];
   Ellipse(x1-rayon,y1-rayon,x1+rayon,y1+rayon);
  end;
End;

Procedure TPlanView.TracePoint(canvas:TCanvas; x,y:Real;Nom:TStr8);
Var deltax,deltay:Real;
    xi,yi : Integer;
Begin
 deltax:=2/UnX;
 deltay:=2/UnY;
 TraceVers(canvas,x-deltax,y,0);
 TraceVers(canvas,x+deltax,y,1);
 TraceVers(canvas,x,y-deltay,0);
 TraceVers(canvas,x,y+deltay,1);
 if Nom<>'' then
  begin
   CoordEcran(x,y,xi,yi);
   canvas.TextOut(xi+2,yi+2,Nom);
 end;
End;

Procedure TPlanView.TraceDroite(canvas:TCanvas; a,b,c:Real);
Var x1,y1,x2,y2:Real;
    limite:Real;
Begin
 if b=0 then
  begin
   x1:=-c/a; x2:=-c/a;
   y1:=YbFen; y2:=YhFen;
  end
  else if a=0 then
   begin
    x1:=XgFen; x2:=XdFen;
    y1:=-c/b; y2:=-c/b;
   end
  else
   begin
    limite:=YhFen/XdFen;
    if abs(-a/b)<=limite then
     begin
      x1:=XgFen; x2:=XdFen;
      y1:=(-x1*a-c)/b; y2:=(-x2*a-c)/b;
     end
    else
     begin
      y1:=YbFen; y2:=YhFen;
      x1:=(-y1*b-c)/a; x2:=(-y2*b-c)/a;
     end;
    end;
 TraceVers(canvas,x1,y1,0);
 TraceVers(canvas,x2,y2,1);
End;

END.

{                         Fin du fichier OPLAN.PAS                          }
