Unit Oyfxview;
{ objet permettant de dessiner des courbes dans un TPlanView }

INTERFACE

Uses Classes, Graphics, OPlan, UCalk;

Type

 PYfxView = ^TYfxView;
 TYfxView = object(TPlanView)
  Constructor Init(l,h:Integer);
  Procedure CalcXY(node:TFormulHandle; t:Real; Var x,y:Real; Var Ok:Boolean); virtual;
  Procedure TraceCourbe(canvas:TCanvas; node:TFormulHandle; mini,maxi,pas:Real);
  End;


IMPLEMENTATION

{ objet TYfxView }

Constructor TYfxView.Init(l,h:Integer);
Begin
 TPlanView.Init(l,h);
End;

Procedure TYfxView.CalcXY(Node:TFormulHandle; t:Real; Var x,y:Real; Var Ok:Boolean);
Var erreur:Boolean;
Begin
 if Node=0 then
  ok:=false
 else
  begin
   x:=t;
   DefVar(node,'X',t);
   Eval(Node,y,erreur);
   ok:=not erreur;
   if not ok then GetErrorMsg(node);
  end;
End;

Procedure TYfxView.TraceCourbe(canvas:TCanvas; node:TFormulHandle; mini,maxi,pas:Real);
{ procdure principale : effectue le trac de la courbe }
Var PlotFlag:Byte;  { drapeau indiquant comment relier 2 points }
                    { PlotFlag=0 pour le premier point  trouver }
                    { PlotFlag=1 si le dernier point tait dans la fentre
                      graphique}
                    { PlotFlag=2 si le dernier point tait  l'extrieur
                      de la fentre graphique }
    xu,yu,t:Real;   { coordonnes utilisateur et paramtre }
    ok:Boolean;     { calcul russi }

 Function Dedans(x,y:Real):Boolean;
 Begin
  Dedans:=(x>=XgFen) and (x<=XdFen) and (y<=YhFen) and (y>=YbFen);
 End;

Begin
 {initialisations}
 PlotFlag:=0;
 t:=mini;
 if ModeCouleur then canvas.pen.color:=ColorAttr[couleurtrace]
 else canvas.pen.color:=ColorAttr[noir];
 { boucle de trac }
 repeat
  CalcXY(node,t,xu,yu,ok);
  if ok then { si le calcul s'est effectu correctement }
   begin
    case PlotFlag of
     1: begin
         TraceVers(canvas,xu,yu,1); { on relie au dernier point }
         if not Dedans(xu,yu) then
          PlotFlag:=2;        { on indique la sortie }
        end;
     2: if Dedans(xu,yu) then
         begin  { on revient dans la fentre }
          PlotFlag:=1;         { graphique cran }
          TraceVers(canvas,xu,yu,1);    { relier }
         end
        else TraceVers(canvas,xu,yu,0);
     0: begin
         TraceVers(canvas,xu,yu,0);
         if Dedans(xu,yu) then
          PlotFlag:=1    { tracer le premier point }
         else PlotFlag:=2;   { premier point  l'extrieur }
        end;
     end;
   end
   else PlotFlag:=0;  { on n'est pas dans le domaine de dfinition }
  t:=t+pas;           { valeur suivante du paramtre xu }
 until (t>maxi);      { condition d'arrt du trac }
End;

END.

{                         Fin du fichier OYfxView.Pas                       }
