unit UCalk;
{ interface  calkul.dll }
{ K.B. fvrier 1998 }

interface
 type
  TFormulHandle=Integer; 
  { ce type permet d'identifier un environnement de calcul }

  TIdentItem=String[20];
  { ce type est  utiliser pour les noms de variables }

 (*------------------------------------------------------------*)
 {les deux fonctions suivantes permettent d'valuer des chanes
  ne faisant pas intervenir de variables}
 (*------------------------------------------------------------*)
 function Calc(S:String; var err:Boolean):Real;
 { value la chane contenue dans S et renvoie le rsultat;
   si une erreur de calcul s'est produite, err prend la valeur true,
   on obtient un message d'erreur avec GetCalcErrorMsg }

 function GetCalcErrorMsg:String;
 { renvoie un message dcrivant l'erreur ventuelle }

 (*------------------------------------------------------------*)
 {les deux procdures suivantes fournissent deux utilitaires :
  - mode angulaire pour les fonctions trigo
  - affichage des nombres de type Real }
 (*------------------------------------------------------------*)

 procedure ModeRadian(b:Boolean);
 { permet de fixer le mode angulaire pour les fonctions
   trigonomtriques :
   b=true donne mode radian
   b=false donne mode degr 
   c'est le mode degr qui est activ par dfaut }

 function FormateReal(r:Real; d:Integer):String;
 { transforme le Real r en chane de caractres avec
   d chiffres aprs la virgule; les 0 aprs la virgule
   sont limins }

 (*------------------------------------------------------------*)
 {les procdures suivantes sont  utiliser lorsqu'on veut faire
  intervenir des variables ou lorsqu'on doit calculer plusieurs
  fois la mme formule (par exemple pour tracer une courbe)}
 {Dmarche  suivre :
  -on commence par demander un handle de formule avec DonneFormule,
  -on compile une chaine S qui contient l'expression  valuer avec
   Compiler, 
  -on value le rsultat avec Eval;
  -lorsqu'on n'a plus besoin de la formule, on la dtruit avec
   FinFormule }
 (*------------------------------------------------------------*)

 function DonneFormule:TFormulHandle;
 {initialisation de l'environnement de calcul}

 procedure FinFormule(var h:TFormulHandle);
 {libration de l'environnement de calcul}

 procedure Compiler(h:TFormulHandle; S:String);
 {interprtation de la chane de caractres}

 function IsValid(h:TFormulHandle):Boolean;
 {indique si l'interprtation a t russie}

 procedure DefVar(h:TFormulHandle; S:TIdentItem; r:Real);
 {dfinir la variable S ou lui affecter une valeur si elle existe
  dj}

 procedure Eval(h:TFormulHandle; var r:Real; var erreur:Boolean);
 {valuation de la formule qui a t pralablement interprte avec
  Compiler; r est le rsultat; erreur indique une erreur de calcul}

 function GetErrorMsg(h:TFormulHandle):String;
 {renvoie le message d'erreur s'il y a lieu}


implementation

 function Calc(S:String; var err:Boolean):Real; external 'CALKUL' index 1;
 function GetCalcErrorMsg:String; external 'CALKUL' index 2;
 procedure ModeRadian(b:Boolean); external 'CALKUL' index 3;
 function FormateReal(r:Real; d:Integer):String; external 'CALKUL' index 4;
 function DonneFormule:TFormulHandle; external 'CALKUL' index 5;
 procedure FinFormule(var h:TFormulHandle); external 'CALKUL' index 6;
 procedure Compiler(h:TFormulHandle; S:String); external 'CALKUL' index 7;
 procedure DefVar(h:TFormulHandle; S:TIdentItem; r:Real); external 'CALKUL' index 8;
 procedure Eval(h:TFormulHandle; var r:Real; var erreur:Boolean); external 'CALKUL' index 9;
 function GetErrorMsg(h:TFormulHandle):String; external 'CALKUL' index 10;
 function IsValid(h:TFormulHandle):Boolean; external 'CALKUL' index 11;
end.
