unit Uyfxw;
{ fentre principale de YFXW }
{ K.B. 99 }

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Menus, Clipbrd, StdCtrls, IniFiles, ShellApi,
  About, Input, Config, OPlan, OYfxView, UCalk, Utils, Grids;

type
  TFormYfx = class(TForm)
    PaintBox: TPaintBox;      { zone de dessin des courbes }
    StringGrid: TStringGrid;  { tableau de valeurs }
    MainMenu: TMainMenu;      { menu principal }
    { lments du menu }
    Menu: TMenuItem;
    Tracer: TMenuItem;
    Configurer: TMenuItem;
    Copier: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    Apropos: TMenuItem;
    Aide: TMenuItem;
    ChangeMode: TMenuItem;
    Fichier: TMenuItem;
    Ouvrir: TMenuItem;
    Sauversous: TMenuItem;
    N4: TMenuItem;
    Quitter: TMenuItem;
    { fin menu }
    OpenDialog: TOpenDialog;  { dialogue ouverture de fichier }
    SaveDialog: TSaveDialog;  { dialogue sauvegarde de fichier }
    LabelSouris: TLabel;      { affichage coordonnes souris }
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure QuitterClick(Sender: TObject);
    procedure AproposClick(Sender: TObject);
    procedure PaintBoxPaint(Sender: TObject);
    procedure CopierClick(Sender: TObject);
    procedure ConfigurerClick(Sender: TObject);
    procedure TracerClick(Sender: TObject);
    procedure PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AideClick(Sender: TObject);
    procedure ChangeModeClick(Sender: TObject);
    procedure OuvrirClick(Sender: TObject);
    procedure StringGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SauversousClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
   yfxview : PYfxView;           { objet interface pour le trac }
   nodes : array[1..4] of TFormulHandle;  { noeuds des fonctions }
   funcstr : array[1..4] of String;      { chanes des fonctions }
   pascalcul : Real;  { pas pour table }
   xdep : Real;       { dbut pour table }
   { formules de calcul des 4 fonctions }
   procedure LireConfig;
   { lecture des donnes de la boite de dialogue de config. }
   procedure EcrireConfig;
   { criture des donnes dans la boite de dialoguer de config. }
   procedure AjouteCourbe(S:String; num:Integer);
   { redfinit la courbe de numro num }
   procedure LireFichier(Nom:String);
   { lecture du fichier de donnes pass en paramtre }
   procedure SauverFichier(Nom:String);
   { sauvegarde des courbes dans un fichier de donnes }
   procedure CalcStringGrid;
   { calcul de la table }
   procedure WMDropfiles(var Msg : TMEssage); message wm_dropfiles;
   { fichier obtenu par drag and drop }
   procedure Affichage;
   { met  jour l'affichage des courbes ou de la table }
   procedure EffaceTable;
   { efface les colonnes inutiles de la table }
   procedure SauveTableau(Nom:String);
   { sauve le tableau de valeurs dans un fichier texte }
   procedure CopierBitmap;
   { copie l'image des courbes dans le presse-papiers }
   procedure CopierTableau;
   { copie la partie du tableau slectionne dans le presse-papiers
     sous forme de texte }
  end;

var
  FormYfx: TFormYfx;
  Couleurs: array[1..4] of Integer;

implementation

{$R *.DFM}

const cartab=#9; { caractre de tabulation }

procedure LireEntier(var n:Integer; S:String; ok:Boolean);
var err:Word;
begin
 val(S,n,err);
 ok:=err=0;
end;

procedure LireNombre(var r:Real; S:String; var ok:Boolean);
var err:Word;
begin
 val(S,r,err);
 ok:=err=0;
end;

procedure TFormYfx.FormCreate(Sender: TObject);
var i:Integer;
begin
 { initialisations des pointeurs }
 for i:=1 to 4 do
  begin
   nodes[i]:=0;
   funcstr[i]:='';
  end;
 pascalcul:=0; xdep:=0;
 { position et taille de la fentre }
 width:=500; height:=400;
 left:=(Screen.Width-width) div 2;
 top:=(Screen.Height-height) div 2;
 PaintBox.Align:=alClient;
 StringGrid.Align:=alClient;
 DragAcceptFiles(Handle,True);
 { table }
 with StringGrid do
  begin
   Cells[0,0]:='X';
   Cells[1,0]:='Y1';
   Cells[2,0]:='Y2';
   Cells[3,0]:='Y3';
   Cells[4,0]:='Y4';
  end;
 { initialisation de YfxView }
 yfxview:=new(PYfxView,Init(PaintBox.ClientWidth,
               PaintBox.ClientHeight));
 with yfxview^ do
  begin
   CouleurFond:=Blanc;
   CouleurTrace:=Bleu;
   CouleurAxes:=Noir;
   Color:=ColorAttr[CouleurFond];
   Fenetre(-8,8,-8,8);
   {PasAxeX:=2; PasAxeY:=2;}
   Options:=opAxes;
  end;
 { initialisation des 4 couleurs }
 Couleurs[1]:=bleu;
 Couleurs[2]:=rouge;
 Couleurs[3]:=vert;
 Couleurs[4]:=brun;

end;

procedure TFormYfx.LireFichier(Nom:String);
var
 S:String;
 f:TIniFile;
 r:Real;
 ok:Boolean;
 i,n:Integer;
begin
 try
  f:=TIniFile.Create(Nom);
  with f do
   begin
    for i:=1 to 4 do
     begin
      S:=ReadString('yfx','y'+IntToStr(i),'');
      Asci2Ansi(S);
      AjouteCourbe(S,i);
     end;
    {n:=ReadInteger('yfx','largeur',ClientWidth);
    FormYfx.ClientWidth:=n;
    n:=ReadInteger('yfx','hauteur',ClientHeight);
    FormYfx.ClientHeight:=n;}
    with YfxView^ do
     begin
      i:=ReadInteger('yfx','points',0);
      if i=1 then Options:=opAxes+opPoints
      else Options:=Options and not opPoints;
      i:=ReadInteger('yfx','quadrillage',0);
      if i=1 then Options:=opAxes+opQuadrillage
      else Options:=Options and not opQuadrillage;
      S:=ReadString('yfx','xmin','rien');
      LireNombre(r,S,ok);
      if ok then YfxView^.XgFen:=r;
      S:=ReadString('yfx','xmax','rien');
      LireNombre(r,S,ok);
      if ok then YfxView^.XdFen:=r;
      S:=ReadString('yfx','ymin','rien');
      LireNombre(r,S,ok);
      if ok then YfxView^.YbFen:=r;
      S:=ReadString('yfx','ymax','rien');
      LireNombre(r,S,ok);
      if ok then YfxView^.YhFen:=r;
      Fenetre(XgFen,XdFen,YbFen,YhFen);
      S:=ReadString('yfx','xgrad','0');
      LireNombre(r,S,ok);
      if ok and (r<>0) then YfxView^.PasAxeX:=abs(r);
      S:=ReadString('yfx','ygrad','0');
      LireNombre(r,S,ok);
      if ok and (r<>0) then YfxView^.PasAxeY:=abs(r);
     end;
     i:=ReadInteger('yfx','couleurs',1);
     ConfigDial.Couleurs.Checked:=(i=1);
     i:=ReadInteger('yfx','trait gras',0);
     ConfigDial.TraitGras.Checked:=(i=1);
   end;
 except
 end;
 f.free;
 EffaceTable;
end;

procedure TFormYfx.SauverFichier(Nom:String);
{ sauvegarde des courbes dans un fichier de donnes }
var
 S:String;
 f:TIniFile;
 r:Real;
 ok:Boolean;
 i,n:Integer;
begin
 try
  f:=TIniFile.Create(Nom);
  with f do
   begin
    for i:=1 to 4 do
     begin
      if nodes[i]<>0 then
       begin
        S:=funcstr[i];
        Ansi2Asci(S);
        WriteString('yfx','y'+IntToStr(i),S);
       end;
     end;
    {n:=ReadInteger('yfx','largeur',ClientWidth);
    FormYfx.ClientWidth:=n;
    n:=ReadInteger('yfx','hauteur',ClientHeight);
    FormYfx.ClientHeight:=n;}
    with YfxView^ do
     begin
      WriteString('yfx','xmin',FormateReal(xgfen,8));
      WriteString('yfx','xmax',FormateReal(xdfen,8));
      WriteString('yfx','ymin',FormateReal(ybfen,8));
      WriteString('yfx','ymax',FormateReal(yhfen,8));
      WriteString('yfx','xgrad',FormateReal(PasAxeX,8));
      WriteString('yfx','ygrad',FormateReal(PasAxeY,8));
      if Options=opAxes+opPoints then
       WriteInteger('yfx','points',1)
      else WriteInteger('yfx','points',0);
      if Options=opAxes+opQuadrillage then
       WriteInteger('yfx','quadrillage',1)
      else WriteInteger('yfx','quadrillage',0);
     end;
     if ConfigDial.Couleurs.Checked then
      WriteInteger('yfx','couleurs',1)
     else WriteInteger('yfx','couleurs',0);
     if ConfigDial.TraitGras.Checked then
      WriteInteger('yfx','trait gras',1)
     else WriteInteger('yfx','trait gras',0);
   end;
 except
 end;
 f.free;
end;

procedure TFormYfx.FormDestroy(Sender: TObject);
{ libration de la mmoire utilise par les pointeurs }
var i:Integer;
begin
 if yfxview<>nil then
  begin
   dispose(yfxview,done);
   yfxview:=nil;
  end;
 for i:=1 to 4 do if nodes[i]<>0 then
  begin
   FinFormule(nodes[i]);
   nodes[i]:=0;
  end;
end;

procedure TFormYfx.FormResize(Sender: TObject);
{ changement de taille de la fentre }
begin
 { largeur et hauteur minimales }
 if Width<100 then Width:=100;
 if Height<100 then Height:=100;
 { largeur des colonnes de la table }
 if StringGrid.Visible then
  begin
   StringGrid.DefaultColWidth:=ClientWidth div 5 - 5;
   ClientWidth:=5*StringGrid.DefaultColWidth+25;
  end;
 { mise  jour de YfxView }
 if yfxview<>nil then
  yfxview^.setdim(PaintBox.ClientWidth, PaintBox.ClientHeight);
end;

procedure TFormYfx.QuitterClick(Sender: TObject);
{ pour quitter le programme }
begin
 close;
end;

procedure TFormYfx.AproposClick(Sender: TObject);
begin
 AboutBox:=TAboutBox.Create(self);
 try
  AboutBox.ShowModal;
 finally
  AboutBox.Free;
 end;
end;

procedure TFormYfx.AjouteCourbe(S:String; num:Integer);
var
 node : TFormulHandle;
 Msg : String;
begin
 if S<>'' then
  begin
   node:=DonneFormule;
   ModeRadian(true);
   DefVar(node,'X',0);
   Compiler(node,S);
  end
 else node:=0;
 if (node<>0) and not IsValid(node) then
  begin
   Msg:='Y'+IntToStr(num)+' : '+GetErrorMsg(node)+#0;
   Application.MessageBox(@Msg[1],'Erreur',IdOk);
   FinFormule(node);
   node:=0;
  end;
 if nodes[num]<>0 then FinFormule(nodes[num]);
 nodes[num]:=node;
 funcstr[num]:=S;
end;

procedure TFormYfx.TracerClick(Sender: TObject);
{ boite de dialogue de dfinition des courbes puis trac }
var rep:Integer;
    node : TFormulHandle;
    S:String;
    i,j:Integer;
begin
 { mise  jour de la boite de dialogue }
 InputForm.InputFonc1.Text:=funcstr[1];
 InputForm.InputFonc2.Text:=funcstr[2];
 InputForm.InputFonc3.Text:=funcstr[3];
 InputForm.InputFonc4.Text:=funcstr[4];
 { affichage de la boite de dialogue }
 rep:=InputForm.ShowModal;
 if (yfxview<>nil) and (rep=idOk) then { rponse Ok }
  begin
   AjouteCourbe(InputForm.InputFonc1.Text,1);
   AjouteCourbe(InputForm.InputFonc2.Text,2);
   AjouteCourbe(InputForm.InputFonc3.Text,3);
   AjouteCourbe(InputForm.InputFonc4.Text,4);
   EffaceTable;
  end;
 Affichage;
end;

procedure TFormYfx.EffaceTable;
var i,j:Integer;
begin
 with StringGrid do
  for i:=1 to 4 do
   begin
    if nodes[i]=0 then
     for j:=1 to RowCount-1 do Cells[i,j]:='';
   end;
end;

procedure TFormYfx.PaintBoxPaint(Sender: TObject);
{ affichage des courbes }
var i:Integer;
begin
 if yfxview<>nil then with yfxview^ do
  begin
   background(PaintBox.canvas);
   for i:=1 to 4 do
    if nodes[i]<>0 then
     begin
      if ConfigDial.Couleurs.Checked then
       CouleurTrace:=Couleurs[i]
      else CouleurTrace:=noir;
      if ConfigDial.TraitGras.Checked then
       PaintBox.Canvas.Pen.Width:=2
      else PaintBox.Canvas.Pen.Width:=1;
      Tracecourbe(PaintBox.canvas,nodes[i],xgfen,xdfen,
                  (xdfen-xgfen)/Largeur);
     end;
   PaintBox.Canvas.Pen.Width:=1;
  end;
end;

procedure TFormYfx.CopierClick(Sender: TObject);
begin
 if YfxView=nil then exit;
 if PaintBox.Visible then CopierBitmap
 else CopierTableau;
end;

procedure TFormYfx.CopierBitmap;
{ copie dans le presse-papiers : on dessine les courbes dans
  un bitmap qu'on envoie dans le presse-papiers }
var
 bitmap:TBitmap;
 i:Integer;
begin
 if YfxView=nil then exit;
 { cration du bitmap }
 bitmap:=TBitmap.create;
 bitmap.Monochrome := True;
 with YfxView^ do
  begin
   { transmission des dimensions }
   bitmap.width:=Largeur;
   bitmap.height:=Hauteur;
   { dessin des courbes }
   ModeCouleur:=false;
   background(bitmap.canvas);
   for i:=1 to 4 do
    if nodes[i]<>0 then
    tracecourbe(bitmap.canvas,nodes[i],xgfen,xdfen,
                 (xdfen-xgfen)/Largeur);
   ModeCouleur:=true;
  end;
 { transfert dans le presse-papiers }
 Clipboard.Assign(bitmap);
 { libration des ressources du bitmap }
 bitmap.free;
end;

procedure TFormYfx.LireConfig;
{ lecture des donnes de la boite de dialogue de configuration }
var
 x1,x2,y1,y2 : Real;
 l,h : Integer;
 ok : Boolean;
begin
 if YfxView=nil then exit;
 with ConfigDial,YfxView^ do
  begin
   LireNombre(x1,InputXmin.Text,ok);
   if ok then LireNombre(x2,InputXmax.Text,ok);
   if ok then LireNombre(y1,InputYmin.Text,ok);
   if ok then LireNombre(y2,InputYmax.Text,ok);
   if ok then Fenetre(x1,x2,y1,y2);
   LireNombre(x1,InputXgrad.Text,ok);
   if ok then PasAxeX:=x1;
   LireNombre(y1,InputYgrad.Text,ok);
   if ok then PasAxeY:=y1;
   if BoutonRien.Checked then
    Options:=opAxes
   else if BoutonPoints.Checked then
    Options:=opAxes+opPoints
   else if BoutonQuadri.Checked then
    Options:=opAxes+opQuadrillage;
   LireEntier(l,InputNbLignes.Text,ok);
   if ok then
    begin
     if l<20 then l:=20;
     if l>100 then l:=100;
     StringGrid.RowCount:=l+1;
    end;
   LireNombre(x1,InputPas.Text,ok);
   if ok then
    if x1<>0 then PasCalcul:=abs(x1);
   LireNombre(x1,InputXdep.Text,ok) ;
   if ok then xdep:=x1;
   LireEntier(l,InputLargeur.Text,ok);
   if ok then
    begin
     LireEntier(h,InputHauteur.Text,ok);
     if ok then
      begin
       if l>Screen.Width-20 then l:=Screen.Width;
       FormYfx.ClientWidth:=l;
       if h>Screen.Height-40 then h:=Screen.Height;
       FormYfx.ClientHeight:=h;
      end;
    end;
  end;
end;

procedure TFormYfx.EcrireConfig;
{ criture des donnes courantes dans la boite de dialogue de
  configuration }
var
 x1,x2,y1,y2 : Real;
 l,h : Integer;
begin
 if YfxView=nil then exit;
 with ConfigDial,YfxView^ do
  begin
   InputXmin.Text:=FormateReal(XgFen,8);
   InputXmax.Text:=FormateReal(XdFen,8);
   InputYmin.Text:=FormateReal(YbFen,8);
   InputYmax.Text:=FormateReal(YhFen,8);
   InputXgrad.Text:=FormateReal(PasAxeX,8);
   InputYgrad.Text:=FormateReal(PasAxeY,8);
   if Options=opAxes then BoutonRien.Checked:=true
   else BoutonRien.Checked:=false;
   if Options=opAxes+opPoints then BoutonPoints.Checked:=true
   else BoutonPoints.Checked:=false;
   if Options=opAxes+opQuadrillage then BoutonQuadri.Checked:=true
   else BoutonQuadri.Checked:=false;
   InputLargeur.Text:=IntToStr(PaintBox.ClientWidth);
   InputHauteur.Text:=IntToStr(PaintBox.ClientHeight);
   InputPas.Text:=FormateReal(PasCalcul,8);
   InputXdep.Text:=FormateReal(xdep,8);
   InputNbLignes.Text:=IntToStr(StringGrid.RowCount-1);
  end;
end;

procedure TFormYfx.ConfigurerClick(Sender: TObject);
{ boite de dialogue Configurer et mise en application }
var rep:Integer;
begin
 EcrireConfig;
 { affichage de la boite de dialogue }
 rep:=ConfigDial.ShowModal;
 if rep=idOk then    { c'est ok }
  begin
   LireConfig;
   Affichage;
  end;
end;

procedure TFormYfx.PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
{ affichage des coordonnes }
begin
 if (Button=mbLeft) and (YfxView<>nil) then with LabelSouris do
  begin
   Caption:=YfxView^.GetCoordMsg(x,y);
   Left:=x-Width;
   Top:=y;
   Show;
  end;
end;

procedure TFormYfx.PaintBoxMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
{ affichage des coordonnes }
begin
 if LabelSouris.Visible and (YfxView<>nil) then with LabelSouris do
  begin
   Caption:=YfxView^.GetCoordMsg(x,y);
   Left:=x-Width;
   Top:=y;
  end;
end;

procedure TFormYfx.PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
{ fin d'affichage des coordonnes }
begin
 if LabelSouris.Visible then LabelSouris.Hide;
end;

procedure TFormYfx.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{ changement de repre par clavier }
var ok:Boolean;
begin
 if (YfxView=nil) or not PaintBox.Visible then exit;
 ok:=false;
 { ok indique si un changement a eu lieu }
 with YfxView^,ConfigDial do
  begin
   case Key of
    VK_Left :
     begin
      Fenetre(XgFen+PasAxeX,XdFen+PasAxeX,YbFen,YhFen);
      ok:=true;
     end;
    VK_Right :
     begin
      Fenetre(XgFen-PasAxeX,XdFen-PasAxeX,YbFen,YhFen);
      ok:=true;
     end;
    VK_Up :
     begin
      Fenetre(XgFen,XdFen,YbFen-PasAxeY,YhFen-PasAxeY);
      ok:=true;
     end;
    VK_Down :
     begin
      Fenetre(XgFen,XdFen,YbFen+PasAxeY,YhFen+PasAxeY);
      ok:=true;
     end;
   end;
   if ok then PaintBox.Repaint;
  end;
end;

procedure TFormYfx.AideClick(Sender: TObject);
begin
 Application.HelpJump('Main_Index');
end;

procedure TFormYfx.WMDropfiles(var Msg : TMEssage);
{ accepte un fichier dropp }
var
 Chaine : PChar;
 Nb : Integer;
 D : Word;
 S : String;
begin
 Nb:=DragQueryFile(Msg.WParam,$FFFF,nil,0);
 if Nb>1 then exit;
 D:=DragQueryFile(Msg.WParam,0,nil,0);
 Chaine:=StrAlloc(D+1);
 DragQueryFile(Msg.WParam,0,Chaine,D+1);
 S:=StrPas(Chaine);
 StrDispose(Chaine);
 LireFichier(S);
 DragFinish(Msg.WParam);
 Affichage;
end;

procedure TFormYfx.ChangeModeClick(Sender: TObject);
var n:Integer;
begin
 if PaintBox.Visible then
  begin
   PaintBox.Hide;
   StringGrid.Show;
   ActiveControl:=StringGrid;
   FormResize(nil);
   CalcStringGrid;
   StringGrid.Row:=1;
   StringGrid.Col:=0;
   ChangeMode.Caption:='Mode Courbe';
  end
 else
  begin
   StringGrid.Hide;
   PaintBox.Width:=ClientWidth;
   PaintBox.Height:=ClientHeight;
   FormResize(nil);
   PaintBox.Show;
   ChangeMode.Caption:='Mode Table';
  end;
end;

procedure TFormYfx.CalcStringGrid;
var
 x,y:Real;
 i,j : Integer;
 erreur : Boolean;
begin
 if YfxView=nil then exit;
 with YfxView^,StringGrid do
  begin
   if pascalcul=0 then pascalcul:=PasAxeX;
   x:=xdep;
   if abs(x)<1E-8 then x:=0;
   i:=1;
   for i:=1 to RowCount-1 do
    begin
     Cells[0,i]:=FormateReal(x,8);
     for j:=1 to 4 do
      if nodes[j]<>0 then
       begin
        DefVar(nodes[j],'X',x);
        Eval(nodes[j],y,erreur);
        if erreur then
         begin
          Cells[j,i]:='erreur';
          GetErrorMsg(nodes[j]);
         end
        else Cells[j,i]:=FormateReal(y,8);
       end;
     x:=x+PasCalcul;
     if abs(x)<1E-8 then x:=0;
    end;
  end;
end;

procedure TFormYfx.SauveTableau(Nom:String);
var
 x,y:Real;
 i,j : Integer;
 erreur : Boolean;
 f:TextFile;
begin
 if YfxView=nil then exit;
 assignfile(f,Nom);
 {$I-}
 rewrite(f);
 {$I+}
 if IOResult<>0 then exit;
 with YfxView^,StringGrid do
  begin
   if pascalcul=0 then pascalcul:=PasAxeX;
   x:=xdep;
   if abs(x)<1E-8 then x:=0;
   i:=1;
   for i:=1 to RowCount-1 do
    begin
     write(f,FormateReal(x,8),cartab);
     for j:=1 to 4 do
      if nodes[j]<>0 then
       begin
        DefVar(nodes[j],'X',x);
        Eval(nodes[j],y,erreur);
        if erreur then
         write(f,'erreur',cartab)
        else write(f,FormateReal(y,8),cartab);
       end;
     writeln(f);
     x:=x+PasCalcul;
     if abs(x)<1E-8 then x:=0;
    end;
  end;
 closefile(f);
end;

procedure TFormYfx.CopierTableau;
var
 x,y:Real;
 i,j : Integer;
 erreur : Boolean;
 S:String;
 SRect: TGridRect;
 L:TMemo;
begin
 if YfxView=nil then exit;
 L:=TMemo.Create(Self);
 L.Parent:=self;
 L.Clear;
 L.Hide;
 with StringGrid do
  begin
   SRect:=Selection;
   for i:=SRect.Top to SRect.Bottom do
    begin
     S:='';
     for j:=SRect.Left to SRect.Right do
      S:=S+Cells[j,i]+cartab;
     L.Lines.Add(S);
    end;
  end;
 L.SelectAll;
 L.CopyToClipBoard;
 L.Free;
end;

procedure TFormYfx.Affichage;
begin
 if PaintBox.Visible then PaintBox.Repaint
 else CalcStringGrid;
end;

procedure TFormYfx.OuvrirClick(Sender: TObject);
begin
 if OpenDialog.Execute then
  begin
   LireFichier(OpenDialog.FileName);
   Affichage;
  end;
end;

procedure TFormYfx.StringGridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 with StringGrid do
  begin
   if (Key=VK_Up) and (Row=1) and (Col=0) then
    begin
     xdep:=xdep-pascalcul; Affichage;
    end;
   if (Key=VK_Down) and (Row=RowCount-1) and (Col=0) then
    begin
     xdep:=xdep+pascalcul; Affichage;
    end;
   if (Key=VK_Next) and (Row=RowCount-1) and (Col=0) then
    begin
     xdep:=xdep+10*pascalcul; Affichage;
    end;
   if (Key=VK_Prior) and (Row=1) and (Col=0) then
    begin
     xdep:=xdep-10*pascalcul; Affichage;
    end;
  end;
end;

procedure TFormYfx.SauversousClick(Sender: TObject);
begin
 if SaveDialog.Execute then
  begin
   SauverFichier(SaveDialog.Filename);
  end;
end;

procedure TFormYfx.FormShow(Sender: TObject);
begin
 { fichier de donnes }
 if paramcount>0 then LireFichier(paramstr(1));
end;

end.
